#!/usr/bin/env node
'use strict';
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_process_1 = __importDefault(require("node:process"));
var commander_1 = require("commander");
var gazeall_1 = require("./lib/gazeall");
node_process_1.default.on('SIGINT', function (code) {
    (0, gazeall_1.StopLaunchedProcesses)();
    node_process_1.default.exit(0);
});
var cmd = new commander_1.Command();
cmd
    .version('gazeall version: 0.13.10', '-v, --version')
    .usage('[options] [files...]')
    .option('-r, --run <command...>', 'run commands then wait for changes to re-run')
    .option('-w, --watch <files...>', 'files to watch for change')
    .option('-W, --wait', 'enter wait, commands will run on changes')
    .option('-p, --npmp <scripts>', 'NPM scripts to run parallel')
    .option('-s, --npms <scripts>', 'NPM scripts to run synchronous')
    .option('-d, --delay <ms>', 'start delay value in milliseconds')
    .option('-H, --halt', 'halt on error')
    .option('-V, --verbose', 'verbose logging')
    .parse(node_process_1.default.argv);
var options = cmd.opts();
options.args = cmd.args;
options.PACKAGE_JSON = (0, gazeall_1.readPackageJSONProperties)();
setTimeout(function () {
    (0, gazeall_1.watchAndRun)(options);
}, parseInt(options['delay']) || 0);
